# WMD examples

In this example, we will evaluate `Word Movers Distance` for News20 dataset and evaluate the top-k accuracy.

The SimSearch library offers CPU and GPU implementations of a low-complexity and high-quality approximation of Earth/Word Mover's Distance.

The details of the approximation algorithm are outlined in "http://export.arxiv.org/abs/1812.02091".


# News20 examples

This test will compare 18828 20Newsgroups documents with each other. For each document in the database, the top-32 nearest neighbors excluding itself will be computed and averaged precision results will be printed.

## Download News20 data and word embeddings

Download 20news-18828.tar.gz from http://qwone.com/~jason/20Newsgroups/, uncompress and move into data directory.

Download GoogleNews-vectors-negative300.bin.gz from the link in the README in https://github.com/mmihaltz/word2vec-GoogleNews-vectors, uncompress and move into data/Embeddings directory.


## Preprocess word2vec embeddings data

Preprocess GoogleNews-vectors-negative300.bin.gz in data/Embeddings directory by executing `python $CONDA_PREFIX/pai4sk/simsearch-examples/wmd/example-20News/preprocess_word2vec_embeddings.py`.
The preprocess script can be run with or without mpirun (or snaprun).

## Run examples

If the user wants to run the example on a single node:
One can run the entire example by executing `python $CONDA_PREFIX/pai4sk/simsearch-examples/wmd/example-20News/example-20News.py`

If the user wants to run the example by distributing the data across multiple nodes:
One can run the entire example by executing `snaprun python $CONDA_PREFIX/pai4sk/simsearch-examples/wmd/example-20News/example-20News.py`

Note:
The datasets should be present in all the machines in the same directory path
location for running the examples in distributed (MPI) mode successfully.

